# Provided by gazelle@yin.interaccess.com
# Port of the Perl program 'client' to T-AWK
# Note that this invokes "usocket.awk" automatically via the awklib feature
extern fork()
extern kill(int,int)
extern getppid()
function error(s) { print "Fatal error:",s > stderr ; abort() }
function octets(l) { local x=pack("@L",l),v;unpack("@B@B@B@B",x,v)
	return sprintf("%d.%d.%d.%d",v[1],v[2],v[3],v[4]) }
BEGIN {
target = ARGC > 1 ? ARGV[1] : "0"
port   = ARGC > 2 ? ARGV[2] : 13
hostname = "mpr-nj"

if (port !~ /^[0-9]+$/) {	# This doesn't work - port is always 0
	if (typeof(val = getservbyname(port,"tcp")) == "uninitialized")
		error("getservbyname")
	for (i in val) print i,val[i]
	print "port =",port = val["s_port"]
	}
if (typeof(val = gethostbyname(hostname)) == "uninitialized")
	error("gethostbyname " hostname)
print "This is",octets(thisaddr = val["h_addr"])
if (typeof(val = gethostbyname(target)) == "uninitialized")
	error("gethostbyname " target)
print "That is",octets(thataddr = val["h_addr"])

# global struct_sockaddr_in = "sin_family@s sin_port@S sin_addr@l @8x"
this = pack(struct_sockaddr_in,AF_INET,0,thisaddr)
that = pack(struct_sockaddr_in,AF_INET,port,thataddr)

# Make the socket filehandle.  The TAWK socket lib makes this real easy.
if ((S = socket()))
	print "socket ok!"
else
	error("socket")

# Give the socket an address.

if (socket_bind(S,this))
	print "socket_bind ok!"
else
	error("socket_bind")

# Call up the server.

if (socket_connect(S,that))
	print "socket_connect ok!"
else
	error("socket_connect")

# Avoid deadlock by forking.

if ((child = fork())) {	# Parent reads from user and writes the socket
    while (getline < "/dev/tty")
	print > S
    kill(child,9)	# Note: TAWK seems to block some signals, others
    exit		# generate ugly err msgs.  9 seems only clean way...
    }

while (getline < S)	# Child reads the socket and writes to the user
	print
kill(getppid(),15)
}
