# Port of the Perl program 'client' to Win32 T-AWK by Doug Dougherty, 8/20/99
# Note that this invokes "socket.awk" automatically via the awklib feature
# Note also that I took out the stuff relating to fork'ing and reading from
# the socket, because I don't know how to fork in Win32.  So, this is the
# dumbed down version - all it does it reads the socket to the user.
function error(s) { print "Fatal error:",s > stderr ; abort() }
function octets(l) { local x=pack("@L",l),v;unpack("@B@B@B@B",x,v)
	return sprintf("%d.%d.%d.%d",v[1],v[2],v[3],v[4]) }
BEGIN {
target = ARGC > 1 ? ARGV[1] : "0"
port   = ARGC > 2 ? ARGV[2] : 13

if (port !~ /^[0-9]+$/) {	# This doesn't work - port is always 0
	if (typeof(val = getservbyname(port,"tcp")) == "uninitialized")
		error("getservbyname")
	for (i in val) print i,val[i]
	print "port =",port = val["s_port"]
	}
if (typeof(val = gethostbyname(target)) == "uninitialized")
	error("gethostbyname " target)
print "That is",octets(thataddr = val["h_addr"])

# global struct_sockaddr_in = "sin_family@s sin_port@S sin_addr@l @8x"
that = pack(struct_sockaddr_in,AF_INET,port,thataddr)

# Make the socket filehandle.  The Unix TAWK socket lib makes this real easy.
# Unfortunately, under Win32, you still have to pass the 3 args...
if ((S = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)))
	print "socket ok!"
else
	error("socket")

# Call up the server.

if (socket_connect(S,that))
	print "socket_connect ok!"
else
	error("socket_connect")

# If we are chatting with the finger daemon, we must send a blank line.
# If a third arg is set, we will actually finger that user...
if (port == 79) socket_send(S,ARGV[3] "\n")

# This is supposed to work, but doesn't work under Win32
# Note that the latest (5.0d?) version is supposed to fix this, but it doesn't
# while (getline < S)
#	print
# exit

# So, you have to do it this way...
while ((t = socket_recv(S,1000)))	# Read the socket and write the user...
	printf "%s",t
}
